//############################################################################
// ~ International Laser Display Association ~
// ~     ILDA File Format Driver in C++      ~
// ~             Built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_ILDA_MACRO_DEFINITIONS__
#define __EZ_ILDA_MACRO_DEFINITIONS__

//############################################################################
#include "ez_ilda_includes.hpp"

//############################################################################
#define    LASERBOY_VERSION               "LaserBoy 06-19-2008 v3"
#define    LASERBOY_CFG_FILE              "LaserBoy.wtf"
#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-06-03-2008"
#define    LASERBOY_WAVE_VERSION          "LaserBoy06072008"
//----------------------------------------------------------------------------
#define    EZ_ILDA_FRAME_SHARE            (string("./frames/"  ))
#define    EZ_ILDA_PALETTE_SHARE          (string("./palettes/"))
#define    EZ_ILDA_WAVE_SHARE             (string("./waves/"   ))
#define    EZ_ILDA_ADAT_SHARE             (string("./ADAT/"    ))
#define    EZ_ILDA_DXF_SHARE              (string("./dxf/"     ))
#define    EZ_ILDA_BMP_SHARE              (string("./bmp/"     ))
#define    EZ_ILDA_CPP_SHARE              (string("./cpp/"     ))
//----------------------------------------------------------------------------
#define    EZ_ILDA_OK                     0
#define    EZ_ILDA_BAD_HEADER             1
#define    EZ_ILDA_EOF_ERROR              2
#define    EZ_ILDA_FILE_OPEN_FAILED       4
#define    EZ_ILDA_UNKNOWN_FORMAT         8
#define    EZ_ILDA_INCOMPATIBLE_FORMATS   16
#define    EZ_COLOR_POINT_MISSMATCH       32
//----------------------------------------------------------------------------
#define    EZ_WAVE_POSITIVE               1
#define    EZ_WAVE_END_OF_FRAME           2
#define    EZ_WAVE_UNIQUE_FRAME           4
#define    EZ_WAVE_UNIQUE_POINT           8
#define    EZ_WAVE_OFFSETS                16
#define    EZ_WAVE_OPTIMIZED              32
//----------------------------------------------------------------------------
#define    EZ_IN_BOUNDS                   0
#define    EZ_OUT_POS_X                   1
#define    EZ_OUT_NEG_X                  -1
#define    EZ_OUT_POS_Y                   2
#define    EZ_OUT_NEG_Y                  -2
#define    EZ_OUT_POS_Z                   3
#define    EZ_OUT_NEG_Z                  -3
//----------------------------------------------------------------------------
#define    EZ_ILDA_3D_FRAME_DATA          0
#define    EZ_ILDA_2D_FRAME_DATA          1
#define    EZ_ILDA_PALETTE_DATA           2
#define    EZ_ILDA_TRUE_COLOR_DATA        3
//----------------------------------------------------------------------------
#define    EZ_TRUE_COLOR                 -1
#define    EZ_ILDA_DEFAULT                0
#define    EZ_X29                         1
#define    EZ_ILDA_STANDARD               2
#define    EZ_DXF                         3
#define    EZ_EZFB_HUES                   4
#define    EZ_REDGREEN                    5
#define    EZ_EZFB_332                    6
#define    EZ_EZFB_323                    7
#define    EZ_EZFB_233                    8
#define    EZ_REDS                        9
#define    EZ_GREENS                      10
#define    EZ_BLUES                       11
#define    EZ_YELLOWS                     12
#define    EZ_MAGENTAS                    13
#define    EZ_CYANS                       14
#define    EZ_GRAYS                       15
#define    EZ_BUILT_IN_PALETTES           16
//----------------------------------------------------------------------------
#define    EZ_ILDA_SHOW_POINTS            1
#define    EZ_ILDA_SHOW_BLANKS            2
#define    EZ_ILDA_SHOW_SELECT            4
#define    EZ_ILDA_SHOW_ORIGIN            8
//----------------------------------------------------------------------------
#define    EZ_ILDA_SELECTED_POINT         1   // 0000 0001
#define    EZ_ILDA_UNIQUE_POINT           32  // 0010 0000
#define    EZ_ILDA_BLANKING_BIT           64  // 0100 0000
#define    EZ_ILDA_LAST_POINT             128 // 1000 0000
//----------------------------------------------------------------------------
#define    EZ_PALETTE_MAX                 256
//----------------------------------------------------------------------------
#define    EZ_ILDA_DEBUG_MESSAGES         0
//----------------------------------------------------------------------------
#define    EZ_STATS_DISPLAY_OFFSET        4
//----------------------------------------------------------------------------
#define    EZ_SHORT_SPAN                  65536
#define    EZ_MAX_USHORT                  65535
#define    EZ_MAX_SHORT                   32767
#define    EZ_MIN_SHORT                  -32768
#define    EZ_HALF_SHORT                  16384
//----------------------------------------------------------------------------
#define    EZFB_BMP_FILE_HEADER_SIZE       54
#define    EZFB_BITS_IN_SHORT              16
#define    EZFB_BITS_IN_CHAR               8
//----------------------------------------------------------------------------
#define    BMP                            (ez_ilda_pointer->bmp)
#define    BACKGROUND                     (ez_ilda_pointer->background)
//----------------------------------------------------------------------------
#ifndef O_BINARY
#define O_BINARY 0
#endif
//----------------------------------------------------------------------------
enum ez_ilda_3D_space  {
                            EZ_ILDA_CUBE         ,
                            EZ_ILDA_SPHERE       ,
                            EZ_ILDA_7_8THS_CUBE  ,
                            EZ_ILDA_7_8THS_SPHERE
                       };

//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
